/*
 * DoubleCheck, a UCI chess playing engine. Copyright (C) 2011 Lucas Braesch.
 * 
 * DoubleCheck is free software: you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * DoubleCheck is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program. If not,
 * see <http://www.gnu.org/licenses/>.
*/
#include "movegen.h"
#include "move.h"
#include "psq.h"

typedef struct {
	move_t m;
	int see, score;
} MoveSort;

typedef struct {
	MoveSort ms[MAX_MOVES];
	int idx, count;
} MoveSortList;

typedef struct {
	move_t best, current, tt;
	int reduction;
	move_t killer[2];
} SearchInfo;

void clear_history();
void history_update(const Board *B, move_t m, int bonus);
int get_history(const Board *B, move_t m);

void gen_msl(const Board *B, MoveSortList *msl, int gen_what, const SearchInfo *si);
MoveSort *next_move(const Board *B, MoveSortList *msl);