/*
 * DoubleCheck, a UCI chess playing engine. Copyright (C) 2011 Lucas Braesch.
 * 
 * DoubleCheck is free software: you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 * 
 * DoubleCheck is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 * 
 * You should have received a copy of the GNU General Public License along with this program. If not,
 * see <http://www.gnu.org/licenses/>.
*/
#pragma once
#include "movesort.h"
#include "tt.h"
#include "eval.h"
#include "uci.h"
#include <time.h>

extern bool Verbose;

extern bool abort_search;
extern uint64_t node_count;

move_t id_loop(Board *B, int max_time, uint64_t max_nodes, int max_depth);
int search(Board *B, int alpha, int beta, int depth, int ply, bool is_pv, SearchInfo *si);
int qsearch(Board *B, int alpha, int beta, int depth, int ply, bool is_pv, SearchInfo *si);
