/*
 * DoubleCheck, a UCI chess playing engine. Copyright (C) 2011 Lucas Braesch.
 *
 * DoubleCheck is free software: you can redistribute it and/or modify it under the terms of the GNU
 * General Public License as published by the Free Software Foundation, either version 3 of the
 * License, or (at your option) any later version.
 *
 * DoubleCheck is distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without
 * even the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the GNU
 * General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License along with this program. If not,
 * see <http://www.gnu.org/licenses/>.
*/
#pragma once
#include "board.h"

/* 64 bit pseudo random number generator */
uint64_t rand64();

/* precalculated zobrist keys */
void init_zobrist();
extern uint64_t zobrist[NB_COLOR][NB_PIECE][NB_SQUARE], zobrist_turn, zobrist_ep[NB_SQUARE], zobrist_castle[16];
extern bool ZobristInitialized;

/* functions to calculate the zobrist key, and the King+Pawn zobrist key from scratch. Note that
 * these are calculated dynamically by the board itself, so these are useful for debugging. */
uint64_t calc_key(const Board *B);
uint64_t calc_kpkey(const Board *B);
